import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class PolygonDemo extends Applet {
    private PolygonCanvas canvas = new PolygonCanvas();
    private Choice typeChooser = new Choice();
    private Checkbox showPointsBox = new Checkbox("Show Points");

	private Polygon [] polygon =
	{
		new NormalPolyline(),
		new NormalPolygon(),
		new NaturalSpline(),
		new DeBoorSpline(),
		new ClosedSpline(),
		new LinearBezier(),
		new QuadricBezier(),
		new CubicBezier(),
	};
	
    public PolygonDemo() {
		setLayout(new BorderLayout());
		Button initButton = new Button("Init");
		Panel buttons = new Panel(new FlowLayout());
		buttons.add(initButton);
		add(buttons, BorderLayout.SOUTH);
		initButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent event) {
				onInit();
			}
		});
		buttons.add(new Label("  "));
		buttons.add(new Label("Polygon type:"));
		buttons.add(typeChooser);
		for (int i = 0; i < polygon.length; ++i)
			typeChooser.add(polygon[i].toString());
		typeChooser.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent event) {
				canvas.setPolygonType(polygon[typeChooser.getSelectedIndex()]);
			}
		});
		typeChooser.select(0);
		canvas.setPolygonType(polygon[0]);
		buttons.add(new Label("  "));
		buttons.add(showPointsBox);
		showPointsBox.setState(true);
		canvas.setPointsVisible(showPointsBox.getState());
		showPointsBox.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent event) {
				canvas.setPointsVisible(showPointsBox.getState());
			}
		});
		add(canvas, BorderLayout.CENTER);
	}

    private void onInit() {
		canvas.clearPoints();
		canvas.repaint();
    }

    public static void main(String [] args) {
		Frame frame = new Frame("Polygon Demo");
		frame.setSize(500, 300);
		frame.add(new PolygonDemo());
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent event) {
				System.exit(0);
			}
		});
		frame.setVisible(true);
	}
}
